# <Copyright 2009 Maciej Sokolowski.>
# Written in one evening. It could be better, it could be more optimized and so on.
# Now - it only works (;
# Feel free to contact me at matemaciek@gmail.com

from PyQt4.QtCore import *
from PyQt4.QtGui import *
from PyKDE4.plasma import Plasma
from PyKDE4 import plasmascript
import subprocess
 
class NvidiaBrightness(plasmascript.Applet):
    def __init__(self,parent,args=None):
        plasmascript.Applet.__init__(self,parent)
 
    def init(self):
        self.setHasConfigurationInterface(False)
        self.setAspectRatioMode(Plasma.IgnoreAspectRatio)
        self.theme = Plasma.Svg(self)
        self.theme.setImagePath("widgets/background")
        self.setBackgroundHints(Plasma.Applet.DefaultBackground)

        self.layout = QGraphicsLinearLayout(Qt.Vertical, self.applet)
        self.Up = Plasma.Label(self.applet)
        self.Up.setText("+")
        self.Up.setAlignment(Qt.AlignVCenter | Qt.AlignHCenter)
        self.layout.addItem(self.Up)
        self.Val = Plasma.Label(self.applet)
        self.Val.setText("----")
        self.Val.setAlignment(Qt.AlignVCenter | Qt.AlignHCenter)
        self.layout.addItem(self.Val)
        self.Down = Plasma.Label(self.applet)
        self.Down.setText("-")
        self.Down.setAlignment(Qt.AlignVCenter | Qt.AlignHCenter)
        self.layout.addItem(self.Down)
        self.applet.setLayout(self.layout)

	self.setMinimumSize(75,90)
        self.resize(80,160)

    def updateVal(self):
        self.Val.setText(str(GetBrightness())+"%")
 
    def paintInterface(self, painter, option, rect):
	self.updateVal()

    def mousePressEvent(self,event):
	if event.buttons() == Qt.LeftButton:
            if event.pos().y()*2<self.contentsRect().height():
	        self.upClick()
            else:
                self.downClick()

    def wheelEvent(self,event):
        self.changeBrightness(event.delta()/120)

    def changeBrightness(self,val):
        SetBrightness(GetBrightness()+val)
        self.updateVal()

    def upClick(self):
        self.changeBrightness(+5)

    def downClick(self):
        self.changeBrightness(-5)
 
def CreateApplet(parent):
    return NvidiaBrightness(parent)

def GetBrightness():
    run = subprocess.Popen("smartdimmer -g | cut -f3 -d\" \"", shell=True, stdout=subprocess.PIPE)
    out, err = run.communicate()
    return int(out)

def SetBrightness(val):
    run = subprocess.Popen("smartdimmer -s "+str(val), shell=True)
    run.communicate()
